summaryrefslogtreecommitdiff
path: root/t/vala-recursive-setup.sh
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2012-11-26 15:15:11 +0100
committerStefano Lattarini <stefano.lattarini@gmail.com>2012-11-26 15:15:11 +0100
commitb4896ce44ca5883bc34a2df0355ed3c8ad19485c (patch)
tree004bfd9be74848a300d7895953a440a03a259156 /t/vala-recursive-setup.sh
parent3e98c9d66b926a50ea7cabce7992bd30da2c6fb8 (diff)
downloadautomake-b4896ce44ca5883bc34a2df0355ed3c8ad19485c.tar.gz
tests: give few vala tests more significant names
* t/vala.sh: Rename ... * t/vala-grepping.sh: ... like this. * t/vala2.sh: Rename ... * t/vala-recursive-setup.sh: ... like this. * t/vala3.sh: Rename ... * t/vala-non-recursive-setup.sh: ... like this. * t/vala4.sh: Rename ... * t/vala-configure.sh: ... like this. * t/vala5.sh: Rename ... * t/vala-per-target-flags.sh: ... like this, and slightly improve heading comments. * t/list-of-tests.mk: Adjust. Signed-off-by: Stefano Lattarini <stefano.lattarini@gmail.com>
Diffstat (limited to 't/vala-recursive-setup.sh')
-rwxr-xr-xt/vala-recursive-setup.sh110
1 files changed, 110 insertions, 0 deletions
diff --git a/t/vala-recursive-setup.sh b/t/vala-recursive-setup.sh
new file mode 100755
index 000000000..2543c78e9
--- /dev/null
+++ b/t/vala-recursive-setup.sh
@@ -0,0 +1,110 @@
+#! /bin/sh
+# Copyright (C) 1996-2012 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+# Test to make sure compiling Vala code really works with recursive make.
+
+required="pkg-config valac gcc GNUmake"
+. test-init.sh
+
+mkdir src
+
+cat >> 'configure.ac' << 'END'
+AC_PROG_CC
+AM_PROG_CC_C_O
+AM_PROG_VALAC([0.7.0])
+PKG_CHECK_MODULES([GOBJECT], [gobject-2.0 >= 2.4])
+AC_CONFIG_FILES([src/Makefile])
+AC_OUTPUT
+END
+
+cat > 'Makefile.am' <<'END'
+SUBDIRS = src
+END
+
+cat > 'src/Makefile.am' <<'END'
+bin_PROGRAMS = zardoz
+zardoz_VALAFLAGS = -H zardoz.h
+zardoz_CFLAGS = $(GOBJECT_CFLAGS)
+zardoz_LDADD = $(GOBJECT_LIBS)
+zardoz_SOURCES = zardoz.vala
+END
+
+cat > 'src/zardoz.vala' <<'END'
+using GLib;
+
+public class Zardoz {
+ public static void main () {
+ stdout.printf ("Zardoz!\n");
+ }
+}
+END
+
+$ACLOCAL
+$AUTOCONF
+$AUTOMAKE -a
+
+grep PKG_CHECK_MODULES configure && skip_ "pkg-config m4 macros not found"
+
+./configure
+$MAKE
+
+# Test rebuild rules.
+
+rm -f src/zardoz.h
+$MAKE -C src zardoz.h
+test -f src/zardoz.h
+rm -f src/zardoz.c
+$MAKE -C src
+test -f src/zardoz.c
+
+echo am--error > src/zardoz.h
+echo am--error > src/zardoz.c
+$sleep
+touch src/zardoz.vala
+$MAKE
+grep 'am--error' src/zardoz.[ch] && exit 1
+
+# Check the distribution.
+
+$MAKE distcheck
+$MAKE distclean
+
+# Tru a VPATH setup.
+
+mkdir build
+cd build
+../configure
+$MAKE
+$MAKE distcheck
+
+# Test rebuild rules from builddir.
+
+rm -f ../src/zardoz.h
+$MAKE -C src ../../src/zardoz.h
+test -f ../src/zardoz.h
+
+rm -f ../src/zardoz.c
+$MAKE
+grep 'Zardoz!' ../src/zardoz.c
+
+$sleep
+sed 's/Zardoz!/FooBar!/' ../src/zardoz.vala > t
+mv -f t ../src/zardoz.vala
+$MAKE
+grep 'FooBar!' ../src/zardoz.c
+grep 'Zardoz!' ../src/zardoz.c && exit 1
+
+: